/* (c) https://github.com/MontiCore/monticore */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: simulationController.proto

package protobuf;

/**
 * Protobuf type {@code SimulationController.SetMapRequest}
 */
public  final class SetMapRequest extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:SimulationController.SetMapRequest)
    SetMapRequestOrBuilder {
private static final long serialVersionUID = 0L;
  // Use SetMapRequest.newBuilder() to construct.
  private SetMapRequest(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private SetMapRequest() {
    mapName_ = "";
    totalChunk_ = 0;
    index_ = 0;
    data_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private SetMapRequest(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!parseUnknownFieldProto3(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
          case 10: {
            java.lang.String s = input.readStringRequireUtf8();

            mapName_ = s;
            break;
          }
          case 18: {
            if (!((mutable_bitField0_ & 0x00000008) == 0x00000008)) {
              data_ = new java.util.ArrayList<com.google.protobuf.ByteString>();
              mutable_bitField0_ |= 0x00000008;
            }
            data_.add(input.readBytes());
            break;
          }
          case 24: {

            totalChunk_ = input.readInt32();
            break;
          }
          case 32: {

            index_ = input.readInt32();
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000008) == 0x00000008)) {
        data_ = java.util.Collections.unmodifiableList(data_);
      }
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return protobuf.SimulationControllerProto.internal_static_SimulationController_SetMapRequest_descriptor;
  }

  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return protobuf.SimulationControllerProto.internal_static_SimulationController_SetMapRequest_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            protobuf.SetMapRequest.class, protobuf.SetMapRequest.Builder.class);
  }

  private int bitField0_;
  public static final int MAPNAME_FIELD_NUMBER = 1;
  private volatile java.lang.Object mapName_;
  /**
   * <code>string mapName = 1;</code>
   */
  public java.lang.String getMapName() {
    java.lang.Object ref = mapName_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      mapName_ = s;
      return s;
    }
  }
  /**
   * <code>string mapName = 1;</code>
   */
  public com.google.protobuf.ByteString
      getMapNameBytes() {
    java.lang.Object ref = mapName_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      mapName_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int TOTALCHUNK_FIELD_NUMBER = 3;
  private int totalChunk_;
  /**
   * <code>int32 totalChunk = 3;</code>
   */
  public int getTotalChunk() {
    return totalChunk_;
  }

  public static final int INDEX_FIELD_NUMBER = 4;
  private int index_;
  /**
   * <code>int32 index = 4;</code>
   */
  public int getIndex() {
    return index_;
  }

  public static final int DATA_FIELD_NUMBER = 2;
  private java.util.List<com.google.protobuf.ByteString> data_;
  /**
   * <code>repeated bytes data = 2;</code>
   */
  public java.util.List<com.google.protobuf.ByteString>
      getDataList() {
    return data_;
  }
  /**
   * <code>repeated bytes data = 2;</code>
   */
  public int getDataCount() {
    return data_.size();
  }
  /**
   * <code>repeated bytes data = 2;</code>
   */
  public com.google.protobuf.ByteString getData(int index) {
    return data_.get(index);
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (!getMapNameBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 1, mapName_);
    }
    for (int i = 0; i < data_.size(); i++) {
      output.writeBytes(2, data_.get(i));
    }
    if (totalChunk_ != 0) {
      output.writeInt32(3, totalChunk_);
    }
    if (index_ != 0) {
      output.writeInt32(4, index_);
    }
    unknownFields.writeTo(output);
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!getMapNameBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, mapName_);
    }
    {
      int dataSize = 0;
      for (int i = 0; i < data_.size(); i++) {
        dataSize += com.google.protobuf.CodedOutputStream
          .computeBytesSizeNoTag(data_.get(i));
      }
      size += dataSize;
      size += 1 * getDataList().size();
    }
    if (totalChunk_ != 0) {
      size += com.google.protobuf.CodedOutputStream
        .computeInt32Size(3, totalChunk_);
    }
    if (index_ != 0) {
      size += com.google.protobuf.CodedOutputStream
        .computeInt32Size(4, index_);
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof protobuf.SetMapRequest)) {
      return super.equals(obj);
    }
    protobuf.SetMapRequest other = (protobuf.SetMapRequest) obj;

    boolean result = true;
    result = result && getMapName()
        .equals(other.getMapName());
    result = result && (getTotalChunk()
        == other.getTotalChunk());
    result = result && (getIndex()
        == other.getIndex());
    result = result && getDataList()
        .equals(other.getDataList());
    result = result && unknownFields.equals(other.unknownFields);
    return result;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + MAPNAME_FIELD_NUMBER;
    hash = (53 * hash) + getMapName().hashCode();
    hash = (37 * hash) + TOTALCHUNK_FIELD_NUMBER;
    hash = (53 * hash) + getTotalChunk();
    hash = (37 * hash) + INDEX_FIELD_NUMBER;
    hash = (53 * hash) + getIndex();
    if (getDataCount() > 0) {
      hash = (37 * hash) + DATA_FIELD_NUMBER;
      hash = (53 * hash) + getDataList().hashCode();
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static protobuf.SetMapRequest parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.SetMapRequest parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.SetMapRequest parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.SetMapRequest parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.SetMapRequest parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.SetMapRequest parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.SetMapRequest parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static protobuf.SetMapRequest parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static protobuf.SetMapRequest parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static protobuf.SetMapRequest parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static protobuf.SetMapRequest parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static protobuf.SetMapRequest parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(protobuf.SetMapRequest prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code SimulationController.SetMapRequest}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:SimulationController.SetMapRequest)
      protobuf.SetMapRequestOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_SetMapRequest_descriptor;
    }

    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_SetMapRequest_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              protobuf.SetMapRequest.class, protobuf.SetMapRequest.Builder.class);
    }

    // Construct using protobuf.SetMapRequest.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
      }
    }
    public Builder clear() {
      super.clear();
      mapName_ = "";

      totalChunk_ = 0;

      index_ = 0;

      data_ = java.util.Collections.emptyList();
      bitField0_ = (bitField0_ & ~0x00000008);
      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_SetMapRequest_descriptor;
    }

    public protobuf.SetMapRequest getDefaultInstanceForType() {
      return protobuf.SetMapRequest.getDefaultInstance();
    }

    public protobuf.SetMapRequest build() {
      protobuf.SetMapRequest result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public protobuf.SetMapRequest buildPartial() {
      protobuf.SetMapRequest result = new protobuf.SetMapRequest(this);
      int from_bitField0_ = bitField0_;
      int to_bitField0_ = 0;
      result.mapName_ = mapName_;
      result.totalChunk_ = totalChunk_;
      result.index_ = index_;
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        data_ = java.util.Collections.unmodifiableList(data_);
        bitField0_ = (bitField0_ & ~0x00000008);
      }
      result.data_ = data_;
      result.bitField0_ = to_bitField0_;
      onBuilt();
      return result;
    }

    public Builder clone() {
      return (Builder) super.clone();
    }
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.setField(field, value);
    }
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return (Builder) super.clearField(field);
    }
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return (Builder) super.clearOneof(oneof);
    }
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return (Builder) super.setRepeatedField(field, index, value);
    }
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.addRepeatedField(field, value);
    }
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof protobuf.SetMapRequest) {
        return mergeFrom((protobuf.SetMapRequest)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(protobuf.SetMapRequest other) {
      if (other == protobuf.SetMapRequest.getDefaultInstance()) return this;
      if (!other.getMapName().isEmpty()) {
        mapName_ = other.mapName_;
        onChanged();
      }
      if (other.getTotalChunk() != 0) {
        setTotalChunk(other.getTotalChunk());
      }
      if (other.getIndex() != 0) {
        setIndex(other.getIndex());
      }
      if (!other.data_.isEmpty()) {
        if (data_.isEmpty()) {
          data_ = other.data_;
          bitField0_ = (bitField0_ & ~0x00000008);
        } else {
          ensureDataIsMutable();
          data_.addAll(other.data_);
        }
        onChanged();
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      protobuf.SetMapRequest parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (protobuf.SetMapRequest) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }
    private int bitField0_;

    private java.lang.Object mapName_ = "";
    /**
     * <code>string mapName = 1;</code>
     */
    public java.lang.String getMapName() {
      java.lang.Object ref = mapName_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        mapName_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>string mapName = 1;</code>
     */
    public com.google.protobuf.ByteString
        getMapNameBytes() {
      java.lang.Object ref = mapName_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        mapName_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>string mapName = 1;</code>
     */
    public Builder setMapName(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      mapName_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>string mapName = 1;</code>
     */
    public Builder clearMapName() {
      
      mapName_ = getDefaultInstance().getMapName();
      onChanged();
      return this;
    }
    /**
     * <code>string mapName = 1;</code>
     */
    public Builder setMapNameBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      mapName_ = value;
      onChanged();
      return this;
    }

    private int totalChunk_ ;
    /**
     * <code>int32 totalChunk = 3;</code>
     */
    public int getTotalChunk() {
      return totalChunk_;
    }
    /**
     * <code>int32 totalChunk = 3;</code>
     */
    public Builder setTotalChunk(int value) {
      
      totalChunk_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>int32 totalChunk = 3;</code>
     */
    public Builder clearTotalChunk() {
      
      totalChunk_ = 0;
      onChanged();
      return this;
    }

    private int index_ ;
    /**
     * <code>int32 index = 4;</code>
     */
    public int getIndex() {
      return index_;
    }
    /**
     * <code>int32 index = 4;</code>
     */
    public Builder setIndex(int value) {
      
      index_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>int32 index = 4;</code>
     */
    public Builder clearIndex() {
      
      index_ = 0;
      onChanged();
      return this;
    }

    private java.util.List<com.google.protobuf.ByteString> data_ = java.util.Collections.emptyList();
    private void ensureDataIsMutable() {
      if (!((bitField0_ & 0x00000008) == 0x00000008)) {
        data_ = new java.util.ArrayList<com.google.protobuf.ByteString>(data_);
        bitField0_ |= 0x00000008;
       }
    }
    /**
     * <code>repeated bytes data = 2;</code>
     */
    public java.util.List<com.google.protobuf.ByteString>
        getDataList() {
      return java.util.Collections.unmodifiableList(data_);
    }
    /**
     * <code>repeated bytes data = 2;</code>
     */
    public int getDataCount() {
      return data_.size();
    }
    /**
     * <code>repeated bytes data = 2;</code>
     */
    public com.google.protobuf.ByteString getData(int index) {
      return data_.get(index);
    }
    /**
     * <code>repeated bytes data = 2;</code>
     */
    public Builder setData(
        int index, com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  ensureDataIsMutable();
      data_.set(index, value);
      onChanged();
      return this;
    }
    /**
     * <code>repeated bytes data = 2;</code>
     */
    public Builder addData(com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  ensureDataIsMutable();
      data_.add(value);
      onChanged();
      return this;
    }
    /**
     * <code>repeated bytes data = 2;</code>
     */
    public Builder addAllData(
        java.lang.Iterable<? extends com.google.protobuf.ByteString> values) {
      ensureDataIsMutable();
      com.google.protobuf.AbstractMessageLite.Builder.addAll(
          values, data_);
      onChanged();
      return this;
    }
    /**
     * <code>repeated bytes data = 2;</code>
     */
    public Builder clearData() {
      data_ = java.util.Collections.emptyList();
      bitField0_ = (bitField0_ & ~0x00000008);
      onChanged();
      return this;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFieldsProto3(unknownFields);
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:SimulationController.SetMapRequest)
  }

  // @@protoc_insertion_point(class_scope:SimulationController.SetMapRequest)
  private static final protobuf.SetMapRequest DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new protobuf.SetMapRequest();
  }

  public static protobuf.SetMapRequest getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<SetMapRequest>
      PARSER = new com.google.protobuf.AbstractParser<SetMapRequest>() {
    public SetMapRequest parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return new SetMapRequest(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<SetMapRequest> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<SetMapRequest> getParserForType() {
    return PARSER;
  }

  public protobuf.SetMapRequest getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

